--
-- kOOL - the church tool
-- www.churchtool.org
--
-- DB changes needed for update from R41a to R42
-- Important: Update DB before updating source
--


-- Update access rights for small group module
UPDATE `ko_admin` SET `kg_admin` = '4' WHERE `kg_admin` = '3';
UPDATE `ko_admin` SET `kg_admin` = '3' WHERE `kg_admin` = '2';
UPDATE `ko_admin` SET `kg_admin` = '2' WHERE `kg_admin` = '1';
UPDATE `ko_admingroups` SET `kg_admin` = '4' WHERE `kg_admin` = '3';
UPDATE `ko_admingroups` SET `kg_admin` = '3' WHERE `kg_admin` = '2';
UPDATE `ko_admingroups` SET `kg_admin` = '2' WHERE `kg_admin` = '1';


-- Raise all access levels for the admin module from 4 to 5
UPDATE `ko_admin` SET `admin` = '5' WHERE `admin` = '4';
UPDATE `ko_admingroups` SET `admin` = '5' WHERE `admin` = '4';


-- New settings
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ('mailing_only_alias', '0');
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ('daten_gs_pid', '');
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ('daten_gs_role', '');
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ('tracking_show_inactive', '1');
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ('leute_force_family_firstname', '0');
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ('daten_pdf_week_length', '7');
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ('res_pdf_week_length', '7');


-- New field for group subscriptions for events
ALTER TABLE `ko_event` ADD `gs_gid` VARCHAR( 20 ) NOT NULL AFTER `url`;
ALTER TABLE `ko_event_mod` ADD `gs_gid` VARCHAR( 20 ) NOT NULL AFTER `url` ;
-- Creation date and last change date for events
ALTER TABLE `ko_event` ADD `cdate` DATETIME NOT NULL, ADD `last_change` DATETIME NOT NULL;
ALTER TABLE `ko_event_mod` ADD `cdate` DATETIME NOT NULL, ADD `last_change` DATETIME NOT NULL;


-- New filter for logins
INSERT INTO `ko_filter` (`id`, `typ`, `dbcol`, `name`, `group`, `allow_neg`, `sql1`, `sql2`, `sql3`, `numvars`, `var1`, `code1`, `var2`, `code2`, `var3`, `code3`) VALUES(NULL, 'leute', 'ko_admin.leute_id', 'logins', 'misc', 0, '`admingroups` REGEXP ''(^|,)[VAR1](,|$)'' AND `disabled` = ''''', '', '', 1, 'usergroup', 'FCN:ko_specialfilter_logins', '', '', '', '');



-- 
UPDATE `ko_help` SET `text` = '<b>2:</b> Neue Reservationen erfassen, die aber je nach Objekt noch moderiert werden.<br /> <b>3: </b>Eigene Reservationen bearbeiten/lschen.<br /> <b>4:</b> Neue Reservationen ohne Moderation erfassen. Alle Reservationen zu den gewhlten Objekten bearbeiten/lschen.<br /> <b>5:</b> Moderieren der Reservations-Anfragen<br /> <b>ALL-Rechte auf 4:</b> Neue Reservations-Gruppen und -Objekte erstellen' WHERE `module` = 'admin' AND `type` = 'login_rights_reservation' AND `language` = 'de' LIMIT 1 ;

UPDATE `ko_help` SET `text` = '<b>2:</b> Add new reservations. Moderation needed for items with moderation.<br /> <b>3: </b>Edit/delete own reservations.<br /> <b>4:</b> Add new reservations without moderation and edit/delete all reservations for the given items.<br /> <b>4:</b> Moderate reservation requests.<br /> <b>ALL rights set to 4:</b> Create new reservation groups and items' WHERE `module` = 'admin' AND `type` = 'login_rights_reservation' AND `language` = 'en' LIMIT 1 ;


-- Change value for userprefs (no=0 instead of 2)
UPDATE `ko_userprefs` SET `value` = '0' WHERE `key` = 'do_mod_email_for_edit_daten' AND `value` = '2';
UPDATE `ko_userprefs` SET `value` = '0' WHERE `key` = 'do_mod_email_for_edit_res' AND `value` = '2';
UPDATE `ko_userprefs` SET `value` = '0' WHERE `key` = 'do_res_email' AND `value` = '2';


-- Donations: New reoccuring options
ALTER TABLE `ko_donations` CHANGE `reoccuring` `reoccuring` VARCHAR( 10 ) NOT NULL;
UPDATE `ko_donations` SET `reoccuring` = '1m' WHERE `reoccuring` = '30';
UPDATE `ko_donations` SET `reoccuring` = '2m' WHERE `reoccuring` = '60';
UPDATE `ko_donations` SET `reoccuring` = '6m' WHERE `reoccuring` = '182';
UPDATE `ko_donations` SET `reoccuring` = '12m' WHERE `reoccuring` = '365';


-- Allow neg for donations filter
UPDATE `ko_filter` SET `allow_neg` = '1' WHERE `name` = 'donation';


-- New help entries
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'leute', 'leute_settings', 'en', '47', '1113', ''), ( NULL , 'leute', 'leute_settings', 'de', '47', '1110', '');
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'reservation', 'list_items', 'en', '45', '242', NULL), ( NULL , 'reservation', 'list_items', 'de', '45', '473', NULL);
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'dp', 'dp_settings_div', 'en', '44', '246', NULL), ( NULL , 'dp', 'dp_settings_div', 'de', '44', '504', NULL);
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'groups', 'groups_settings', 'en', '46', '1119', NULL), ( NULL , 'groups', 'groups_settings', 'de', '46', '1120', NULL);
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'donations', 'donation_settings', 'en', '67', '1123', NULL), ( NULL , 'donations', 'donation_settings', 'de', '67', '1125', NULL);



ALTER TABLE `ko_groups` ADD `rights_del` TEXT NOT NULL AFTER `rights_edit`;
ALTER TABLE `ko_admingroups` ADD `leute_admin_groups` TEXT NOT NULL AFTER `leute_admin_spalten`;
ALTER TABLE `ko_admingroups` ADD `leute_admin_gs` TINYINT UNSIGNED NOT NULL AFTER `leute_admin_groups`;



ALTER TABLE `ko_groups` ADD `rights_del` TEXT NOT NULL AFTER `rights_edit`;
ALTER TABLE `ko_admingroups` ADD `leute_admin_groups` TEXT NOT NULL AFTER `leute_admin_spalten`, ADD `leute_admin_gs` TINYINT UNSIGNED NOT NULL AFTER `leute_admin_groups`;

UPDATE `ko_help` SET `text` = '<b>2:</b> Add people to groups or remove them.<br /> <b>3:</b> Edit groups and add or edit roles.<br /> <b>4:</b> Delete groups and roles.' WHERE `type` = 'login_rights_groups' AND `language` = 'en';
UPDATE `ko_help` SET `text` = '<b>2:</b> Personen Gruppen zuweisen oder Zuweisung aufheben.<br /> <b>3:</b> Gruppen und Rollen bearbeiten.<br /> <b>4:</b> Gruppen und Rollen lschen.' WHERE `type` = 'login_rights_groups' AND `language` = 'de';
