<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2011 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


//Define basic chart types for smallgroup module (may be extended by plugins)
$KG_CHART_TYPES = array("members", "frequency", "weekday", "ages", "types", "regions", "gender");

function ko_list_kg($output=TRUE) {
	global $smarty, $ko_path;
	global $KOTA;
	global $access, $MAILING_PARAMETER;

	ko_get_access('kg');
	if($access['kg']['MAX'] < 1) return;

	//Limit bestimmen
	apply_kg_filter($z_where, $z_limit);
	$rows = db_get_count('ko_kleingruppen', 'id', $z_where);
	ko_get_kleingruppen($es, $z_limit, '', 'WHERE 1=1 '.$z_where);

	//Check for tracking rights
	$show_tracking = FALSE;
	if(ko_module_installed('tracking', $_SESSION['ses_userid'])) {
		ko_get_access('tracking');
		$add_tracking = $access['tracking']['ALL'] > 3;
		$show_tracking = TRUE;
	}

	//Check for mailing rights
	$show_mailing = ko_module_installed('mailing', $_SESSION['ses_userid']);


	//Statistik ber Suchergebnisse und Anzeige
  $stats_end = ($_SESSION["show_kg_limit"]+$_SESSION["show_kg_start"]-1 > $rows) ? $rows : ($_SESSION["show_kg_limit"]+$_SESSION["show_kg_start"]-1);
	$smarty->assign('tpl_stats', $_SESSION["show_kg_start"]." - ".$stats_end." ".getLL("list_oftotal")." ".$rows);


  //Links fr Prev und Next-Page vorbereiten
  if($_SESSION["show_kg_start"] > 1) {
		$smarty->assign("tpl_prevlink_link", "javascript:sendReq('../leute/inc/ajax.php', 'action,set_start,sesid', 'setstartkg,".(($_SESSION["show_kg_start"]-$_SESSION["show_kg_limit"] < 1) ? 1 : ($_SESSION["show_kg_start"]-$_SESSION["show_kg_limit"])).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_prevlink_link', '');
  }
  if(($_SESSION["show_kg_start"]+$_SESSION["show_kg_limit"]-1) < $rows) {
		$smarty->assign("tpl_nextlink_link", "javascript:sendReq('../leute/inc/ajax.php', 'action,set_start,sesid', 'setstartkg,".($_SESSION["show_kg_limit"]+$_SESSION["show_kg_start"]).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_nextlink_link', '');
  }
	$smarty->assign('limitM', $_SESSION['show_kg_limit'] >= 100 ? $_SESSION['show_kg_limit']-50 : max(10, $_SESSION['show_kg_limit']-10));
	$smarty->assign('limitP', $_SESSION['show_kg_limit'] >= 50 ? $_SESSION['show_kg_limit']+50 : $_SESSION['show_kg_limit']+10);
	$smarty->assign('limitAction', 'setstartkg');


	//Header
	$smarty->assign("tpl_show_3cols", TRUE );
	if($show_tracking) $smarty->assign('tpl_show_tracking_col', TRUE);
	if($show_mailing) $smarty->assign('tpl_show_mailing_col', TRUE);

	foreach($_SESSION["show_kg_cols"] as $c_i => $c) {
		if($c != "") {
			$tpl_table_header[$c_i]["sort"] = $c;
			$tpl_table_header[$c_i]["name"] = getLL("kg_listheader_".$c);
		}//if(c)
	}

  $smarty->assign("tpl_table_header", $tpl_table_header);
  $smarty->assign("sort", array("show" => TRUE,
																"action" => "setsortkg",
																"akt" => $_SESSION["sort_kg"],
																"akt_order" => $_SESSION["sort_kg_order"])
	);
	$smarty->assign("module", "leute");
	$smarty->assign("sesid", session_id());


	//Multiedit-Spalten definieren
	if($access['kg']['MAX'] > 2) {
		$smarty->assign("tpl_show_editrow", TRUE);
		$edit_columns = array();
		foreach($_SESSION["show_kg_cols"] as $col) {
			$edit_columns[] = isset($KOTA["ko_kleingruppen"][$col]) ? $col : "";
		}
		$smarty->assign("tpl_edit_columns", $edit_columns);
	} else {
		$smarty->assign("tpl_show_editrow", FALSE);
	}



	//Eigentliche Daten ausgeben
	foreach($es as $e_i => $e) {
		//Checkbox
    $tpl_list_data[$e_i]["show_checkbox"] = TRUE;

		//Edit-Button
		if($access['kg']['MAX'] > 2) {
      $tpl_list_data[$e_i]["show_edit_button"] = TRUE;
      $tpl_list_data[$e_i]["alt_edit"] = getLL('ko_kleingruppen_change');
      $tpl_list_data[$e_i]["onclick_edit"] = "javascript:set_action('edit_kg');set_hidden_value('id', '$e_i');this.submit";
    } else {
	    $tpl_list_data[$e_i]["show_edit_button"] = FALSE;
    }

    //Delete-Button
		if($access['kg']['MAX'] > 3) {
	    $tpl_list_data[$e_i]["show_delete_button"] = TRUE;
 	  	$tpl_list_data[$e_i]["alt_delete"] = getLL('ko_kleingruppen_delete');
      $tpl_list_data[$e_i]["onclick_delete"] = "javascript:c = confirm('" . getll('ko_kleingruppen_confirm_delete') . "');if(!c) return false;set_action('delete_kg');set_hidden_value('id', '$e_i');";
    } else {
      $tpl_list_data[$e_i]["show_delete_button"] = FALSE;
    }

		//Tracking
		if($show_tracking) {
			//Find a tracking for this small group
			$tracking = db_select_data('ko_tracking', 'WHERE `filter` = \''.$e_i.'\'', '*', '', 'LIMIT 0,1', TRUE);
			if(isset($tracking['id']) && ($access['tracking']['ALL'] > 0 || $access['tracking'][$tracking['id']] > 0)) {  //Found a tracking with access to it
				$tpl_list_data[$e_i]['tracking_mode'] = 'show';
				$tpl_list_data[$e_i]['alt_tracking'] = getLL('tracking_kg_show');
				$tpl_list_data[$e_i]['onclick_tracking'] = "javascript:jumpToUrl('".$ko_path."tracking/index.php?action=enter_tracking&amp;id=".$tracking['id']."'); return false;";
			} else if($add_tracking) {  //No tracking so show add link if access rights are 4@ALL
				$tpl_list_data[$e_i]['tracking_mode'] = 'add';
				$tpl_list_data[$e_i]['alt_tracking'] = getLL('tracking_kg_add');
				$tpl_list_data[$e_i]['onclick_tracking'] = "javascript:sendReq('".$ko_path."leute/inc/ajax.php', 'action,id,sesid', 'addkgtracking,$e_i,".session_id()."', do_element); return false;";
			} else {  //else don't show anything
				$tpl_list_data[$e_i]['tracking_mode'] = '';
			}
		}

		//Mailing: Show email link
		if($show_mailing && $MAILING_PARAMETER['domain'] != '') {
			$tpl_list_data[$e_i]['alt_mailing'] = getLL('mailing_send_email');
			if($e['mailing_alias'] != '') {
				$link = $e['mailing_alias'].'@'.$MAILING_PARAMETER['domain'];
			} else if(!ko_get_setting('mailing_only_alias')) {
				$link = 'sg'.$e['id'].'@'.$MAILING_PARAMETER['domain'];
			} else {
				$link = '';
			}
			$tpl_list_data[$e_i]['mailing_link'] = $link;
		}

	  //Index
    $tpl_list_data[$e_i]["id"] = $e_i;

		//Anzuzeigende Spalten einfllen
		$colcounter = -1;
		$tpl_list_cols = array(); //Array lschen.
		kota_process_data("ko_kleingruppen", $e, "list", $log, $e_i);
		foreach($_SESSION["show_kg_cols"] as $c) {
			if($c != "") {
				$colcounter++;
				$tpl_list_cols[] = $colcounter;
				if($c == "name") {
					$tpl_list_data[$e_i][$colcounter] = '<a href="index.php?action=set_kg_filter&amp;id='.$e_i.'"><b>'.ko_html($e[$c]).'</b></a>';

					$show_leiter = "";
					foreach(explode(',', $e['role_L']) as $l) {
						if(!$l) continue;
						ko_get_person_by_id($l, $p);
						if($p["vorname"] && $p["nachname"]) $show_leiter .= $p["vorname"]." ".$p["nachname"].", ";
					}
					$tpl_list_data[$e_i][$colcounter] .= $show_leiter ? " (".substr($show_leiter, 0, -2).")" : " ( - )";
				} else {
					if($KOTA["ko_kleingruppen"][$c]["list"]) {
						$tpl_list_data[$e_i][$colcounter] = $e[$c];
					} else {
						$ll_value = getLL("ko_kleingruppen_".$c."_".$e[$c]);
						$tpl_list_data[$e_i][$colcounter] = ko_html(($ll_value ? $ll_value : $e[$c]));
					}
				}
			}
		}

	}//foreach(es)

	$smarty->assign("tpl_list_title", getLL("kg_list_title"));
	$smarty->assign('db_table', 'ko_kleingruppen');
	$smarty->assign('db_cols', $_SESSION['show_kg_cols']);
	$smarty->assign('tpl_list_cols', $tpl_list_cols);
  $smarty->assign('tpl_list_data', $tpl_list_data);
	if($output) {
	  $smarty->display('ko_list.tpl');
	} else {
	  print $smarty->fetch('ko_list.tpl');
	}
}//ko_list_kg()






function ko_kg_formular($mode, $id=0) {
	global $ko_path, $smarty;
	global $KOTA;
	global $access;

	if($mode == "edit" && $id) {
		if($access['kg']['MAX'] < 3) return;
	} else if($mode == "neu") {
		if($access['kg']['MAX'] < 4) return;
		$id = 0;
		//$kg = array();
	} else return;

	$form_data["title"] = $mode == "neu" ? getLL("kota_ko_kleingruppen_new") : getLL("kota_ko_kleingruppen_change");
  $form_data["submit_value"] = getLL("save");
  $form_data["action"] = $mode == "neu" ? "submit_neue_kg" : "submit_edit_kg";
	$form_data["cancel"] = "list_kg";

	ko_multiedit_formular("ko_kleingruppen", "", $id, "", $form_data);
}//ko_kg_formular()




function ko_kg_update_people() {
	$all_kgs = db_select_data('ko_kleingruppen', 'WHERE 1=1');
	$all_ids = array_keys($all_kgs);

	$people = db_select_data('ko_leute', "WHERE `smallgroups` != ''", 'id,smallgroups');
	foreach($people as $p) {
		$p_kgs = explode(',', $p['smallgroups']);
		$new_kgs = array();
		foreach($p_kgs as $kg) {
			if(in_array(substr($kg, 0, 4), $all_ids)) {
				$new_kgs[] = $kg;
			}
		}
		$new = implode(',', $new_kgs);
		if($new != $p['smallgroups']) {
			db_update_data('ko_leute', "WHERE `id` = '".$p['id']."'", array('smallgroups' => $new));
		}
	}
}//ko_kg_update_people()




/**
 * Shows smallgroup charts
 */
function ko_kg_chart($_type="") {
	global $KG_CHART_TYPES;
	
	//Call all chart functions
	$html = array();
	foreach($KG_CHART_TYPES as $type) {
		if(!function_exists("ko_kg_chart_".$type)) continue;
		$html[$type] = call_user_func("ko_kg_chart_".$type);
	}

	if($_type) {
		$out = '<label>'.getLL("kg_chart_title_".$type).'</label>'.$html[$type];
	} else {
		//Generate HTML output
		$out = '<div class="list_title">'.getLL("kg_chart_title").'</div><br clear="all" />';
		foreach($html as $type => $code) {
			$out .= '<div class="leute_chart" name="kg_chart_'.$type.'" id="kg_chart_'.$type.'"><label>'.getLL("kg_chart_title_".$type).'</label>'.$code.'</div>';
		}
		$out .= '<br clear="all" />';
	}

	return $out;
}//ko_kg_chart()



function ko_kg_chart_types() {
	global $ko_path;

	$value = $lavel = array();
	$query = "SELECT `type`, COUNT(`id`) AS num FROM `ko_kleingruppen` GROUP BY `type` ORDER BY `num` DESC";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$label[] = $row["type"] != "" ? $row["type"] : getLL("leute_chart_none");
		$value[] = $row["num"];
	}

	//Create img link for preview chart
	$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$r .= '&size=400x250&yValueMode=3&textXOrientation=vertical';
	$r .= '" />';

	//Create img link for popup to show bar chart a bit bigger
	$p  = $ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$p .= '&size=1000x550&yValueMode=3&textXOrientation=vertical';

	return '<a href="'.$p.'" target="_blank">'.$r.'</a>';
}



function ko_kg_chart_regions() {
	global $ko_path;

	$value = $lavel = array();
	$query = "SELECT `region`, COUNT(`id`) AS num FROM `ko_kleingruppen` GROUP BY `region` ORDER BY `num` DESC";
	$result = mysql_query($query);
	while($row = mysql_fetch_assoc($result)) {
		$label[] = $row["region"] != "" ? $row["region"] : getLL("leute_chart_none");
		$value[] = $row["num"];
	}

	//Create img link for preview chart
	$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$r .= '&size=400x250&yValueMode=3&textXOrientation=vertical';
	$r .= '" />';

	//Create img link for popup to show bar chart a bit bigger
	$p  = $ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$p .= '&size=1000x550&yValueMode=3&textXOrientation=vertical';

	return '<a href="'.$p.'" target="_blank">'.$r.'</a>';
}




function ko_kg_chart_members() {
	global $ko_path;

	$_label = $_value = array();
	$kgs = db_select_data('ko_kleingruppen', 'WHERE 1', '*', 'ORDER BY name ASC');
	foreach($kgs as $kgid => $kg) {
		$_value[] = db_get_count('ko_leute', 'id', "AND `smallgroups` REGEXP '$kgid:M' AND `deleted` = '0' ".ko_get_leute_hidden_sql());
		$_label[] = $kg["name"];
	}
	//Sort descending by num
	arsort($_value);
	$value = $label = array();
	foreach($_value as $vi => $v) {
		$value[] = $v;
		$label[] = ko_truncate($_label[$vi], 20);
		$label_short[] = ko_truncate($_label[$vi], 10);
	}

	//Create img link for preview chart
	$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label_short));
	$r .= '&size=400x250&yValueMode=0&textXOrientation=vertical';
	$r .= '" />';

	//Create img link for popup to show bar chart a bit bigger
	$width = sizeof($value) > 60 ? 1500 : 1000;
	$p  = $ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$p .= '&size='.$width.'x550&yValueMode=3&textXOrientation=vertical';

	return '<a href="'.$p.'" target="_blank">'.$r.'</a>';
}




function ko_kg_chart_gender() {
	return ko_leute_chart_generic_pie_enum("ko_kleingruppen", "", "geschlecht", "kota_ko_kleingruppen_geschlecht_");
}



function ko_kg_chart_weekday() {
	global $ko_path;

	$data = ko_leute_chart_generic_pie_enum("ko_kleingruppen", "", "wochentag", "kota_ko_kleingruppen_wochentag_", TRUE);
	$value = $data["value"];
	$label = $data["label"];

	//Create img link for preview chart
	$out  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$out .= '&size=400x250&yValueMode=3&textXOrientation=vertical';
	$out .= '" />';

	return $out;
}//ko_kg_chart_kg_weekday()



function ko_kg_chart_frequency() {
	global $ko_path;

	$data = ko_leute_chart_generic_pie_enum("ko_kleingruppen", "", "treffen", "kota_ko_kleingruppen_treffen_", TRUE);
	$value = $data["value"];
	$label = $data["label"];

	//Create img link for preview chart
	$out  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$out .= '&size=400x250&yValueMode=3&textXOrientation=vertical';
	$out .= '" />';

	return $out;
}//ko_kg_chart_kg_frequency()





/**
 * Number of smallgroups by the age span they cover
 */
function ko_kg_chart_ages() {
	global $ko_path;

	$kgs = db_select_data("ko_kleingruppen", "WHERE 1");
	$data = array();
	foreach($kgs as $kg) {
		list($min, $max) = explode("-", $kg["alter"]);
		$min = (int)$min; $max = (int)$max;
		if(!$min || !$max || $min > $max) continue;
		for($i = $min; $i <= $max; $i++) {
			$data[$i] += 1;
		}
	}

	ksort($data);
	$value = $label = array();
	foreach($data as $k => $v) {
		$value[] = $v;
		$label[] = $k;
	}

	//Create img link for preview chart
	$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$r .= '&size=400x250&yValueMode=0&xStep=10';
	$r .= '" />';

	//Create img link for popup to show bar chart a bit bigger
	$p  = $ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$p .= '&size=1000x450&yValueMode=3&xStep=5';

	$out = '<a href="'.$p.'" target="_blank">'.$r.'</a>';

	return $out;
}//ko_kg_chart_kg_ages()




/**
 * Create Excel export of all small groups
 * Applies current filter and uses itemset with name 'xls' if given - otherwise all columns will show in export
 */
function ko_kg_export_xls() {
	global $access, $KOTA, $ko_path;

	if($access['kg']['ALL'] < 2) return FALSE;

	$ignore_cols = array('id', 'eventGroupID');

	apply_kg_filter($z_where, $z_limit);
	ko_get_kleingruppen($kleingruppen, '', '', 'WHERE 1 '.$z_where);

	//Get columns from preset 'xls' if given, otherwise use all
	$value = ko_get_userpref($_SESSION['ses_userid'], 'xls', 'leute_kg_itemset');
	if($value[0]['value']) {
		$cols = explode(',', $value[0]['value']);
	} else {
		$_cols = db_get_columns('ko_kleingruppen');
		array_splice($_cols, 8, 0, array(array('Field' => 'anz_leute')));
		foreach($_cols as $col) {
			$cols[] = $col['Field'];
		}
	}

	//Table header
	$header = array();
	foreach($cols as $c) {
		if(in_array($c, $ignore_cols)) continue;
		$header[] = getLL('kg_listheader_'.$c);
		if($c == 'name') $header[] = getLL('kg_roles_L');
	}

	$row = 0;
	foreach($kleingruppen as $i => $kg) {
		kota_process_data('ko_kleingruppen', $kg, 'list', $log, $i);
		$col = 0;
		foreach($cols as $c) {
			if(in_array($c, $ignore_cols)) continue;

			if($c == 'name') {
				$data[$row][$col] = $kg[$c];
				//Add column with leaders
				if($kg['role_L'] != '') {
					$leaders = db_select_data('ko_leute', "WHERE `id` IN (".$kg['role_L'].")", 'id,vorname,nachname', 'ORDER BY `nachname`, `vorname` ASC');
					$leader_value = array();
					foreach($leaders as $l) {
						$leader_value[] = $l['vorname'].' '.$l['nachname'];
					}
					$data[$row]['_leaders'] = implode(', ', $leader_value);
				} else {
					$data[$row]['_leaders'] = '';
				}
			} else {
				$ll_value = getLL('ko_kleingruppen_'.$c.'_'.$kg[$c]);
				$data[$row][$col] = $ll_value ? $ll_value : strip_tags($kg[$c]);
			}
			$col++;
		}//foreach(cols as c)
		$row++;
	}//foreach(kleingruppen as kg)


	//Write XLS
	$dateiname = $ko_path.'download/excel/'.getLL('kg_xls_export_filename').strftime('%d%m%Y_%H%M%S', time()).'.xls';
	ko_export_to_excel($header, $data, $dateiname, getLL('kota_ko_leute_smallgroups'));

	return $dateiname;
}//ko_kg_export_xls()




function apply_kg_filter(&$z_where, &$z_limit) {
	global $access;

	//Limit
	$z_limit = 'LIMIT '.($_SESSION['show_kg_start']-1).', '.$_SESSION['show_kg_limit'];

	//Only show own small groups if access level is 1
	if($access['kg']['ALL'] < 2) {
		$kgids = kg_get_users_kgid();
		if(sizeof($kgids) == 0) return;
		$z_where .= ' AND `id` IN ('.implode(',', $kgids).') ';
	}

	//Don't add any filters if none are set
	if(!isset($_SESSION['kg_filter']) || sizeof($_SESSION['kg_filter']) == 0) return;

	//SQL where
	foreach($_SESSION['kg_filter'] as $field => $value) {
		if(!$value) continue;
		switch($field) {
			case 'name':
				$z_where .= ' AND `'.$field.'` REGEXP \'.*'.$value.'.*\' ';
			break;
			case 'geschlecht':
			case 'wochentag':
			case 'treffen':
			case 'type':
			case 'region':
				$z_where .= ' AND `'.$field.'` = \''.$value.'\' ';
			break;
		}
	}
}//apply_kg_filter()
?>
